/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.artifacts.uinfo.salix;

import org.dive4elements.artifactdatabase.state.Facet;
import org.dive4elements.river.artifacts.common.ResultFacet;
import org.dive4elements.river.artifacts.states.DefaultState.ComputeType;

/**
 * Facet of the U-Info salix scenario curve.
 */
public class SalixScenarioResultFacet extends ResultFacet {

    private static final long serialVersionUID = 1L;

    private int dataIndex;

    public SalixScenarioResultFacet() {
        // required for clone operation deepCopy()
    }

    public SalixScenarioResultFacet(final int facetIndex, final int resultIndex, final int dataIndex, final String name, final String description,
            final String yAxisLabelKey, final String hash, final String id) {
        super(facetIndex, resultIndex, name, description, yAxisLabelKey, ComputeType.ADVANCE, id, hash);

        this.dataIndex = dataIndex;
    }

    /** Copy deeply. */
    @Override
    public Facet deepCopy() {
        // FIXME: why not simply use the full constructor instead?
        final SalixScenarioResultFacet copy = new SalixScenarioResultFacet();
        // FIXME: why does DataFacet does not override set? Bad access to variables of parent!
        copy.set(this);
        copy.type = this.type;
        copy.hash = this.hash;
        copy.stateId = this.stateId;
        copy.dataIndex = this.dataIndex;
        return copy;
    }

    public int getDataIndex() {
        return this.dataIndex;
    }
}